<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Users;
use app\models\Artcentre;
use yii\helpers\ArrayHelper;
use app\models\Userrole;

/**
 * ArtcentreSearch represents the model behind the search form about `app\models\Users`.
 */
class ArtcentreSearch extends Artcentre
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['artc_id', 'create_user', 'update_user'], 'integer'],
            [['district','artcname','artccode', 'status', 'create_time', 'update_time','record_date'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
	   $sdistrict=Yii::$app->user->identity->district;  
	   
	    $Locs = ArrayHelper::map(Userrole::find()->where(["user_id" => $Usermodel->usr_id])->asArray()->all(), 'authorized_loc', 'authorized_loc');
        $loc = "'" . implode($Locs, "','") . "'";

		if($UserRole == 1) 
		  $query = Artcentre::find();
		elseif($UserRole == 2) 
		  $query = Artcentre::find()->where("artccode IN ($loc)");
		elseif($UserRole == 3) 
		  $query = Artcentre::find()->where(["artccode"=>$sloc]);   		  

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
			'sort'=>[
                'defaultOrder'=>['artccode'=> SORT_ASC],
            ],
        ]);
        if(empty($params))
            $params = Yii::$app->request->post();
        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'artc_id' => $this->artc_id,		
            'status' => $this->status,			
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,           
        ]);

        $query->andFilterWhere(['like', 'artcname', $this->artcname])
		      ->andFilterWhere(['like', 'artccode', $this->artccode])
		      ->andFilterWhere(['like', 'district', $this->district]);          
           
        return $dataProvider;
    }
}
